'Lsung:
'-------
'1407-Software-Rtsel (mit Pollin-LCD, TxD-Pin3 sollte auch funktionieren)
'-------------------------------------------------------------------------------
$regfile = "attiny2313.dat"
$crystal = 1000000                             'ab Werk
$crystal = 8000000
$baud = 9600

Lcdddr Alias Ddrd.6 : Lcdout Alias Portd.6     'Lcd
Set Lcdddr : Set Lcdout                        'Lcd-Speisung
Config Lcdpin = Pin , Db4 = Portb.0 , Db5 = Portb.1 , Db6 = Portb.2 , Db7 = Portb.3 , E = Porta.0 , Rs = Porta.1
Initlcd : Cursor Off

Declare Sub Decoder
Declare Sub Codiere

Dim S As String * 1
Dim Index0 As Byte , Index1 As Byte
Dim Temp0 As Byte , Temp1 As Byte , Temp2 As Byte
'-------------------------------------------------------------------------------
Do
   Restore Dta0 : Decoder                      'Zeiger auf Rtsel-String
   Restore Dta1 : Codiere                      'Zeiger auf Rtsel-String
   Restore Dta2 : Decoder                      'Zeiger auf Test-String
   Restore Dta3 : Codiere                      'Zeiger auf Test-String
Loop
End
'-------------------------------------------------------------------------------
' lineares Schieberegister: Bit5 XOR Bit0, nach Rechtsverschiebung in Bit5
Sub Decoder
   Cls                                         '1.Zeile zu 8 Zeichen
   For Index0 = 0 To 1                         '2 Zeilen
      For Index1 = 1 To 8                      'zu 8 Zeichen
         Read S                                'hol ein Zeichen
         S = Ucase(s)                          'nur Grossbuchstaben
         Temp0 = Asc(s) - 32                   'Bereich asc(32-95) auf 0-63 holen

         Temp1 = Temp0 And 1                   'Bit0 isolieren
         Shift Temp1 , Left , 5                'nach Bit5 schieben

         Temp2 = Temp0 And 32                  'Bit5 isolieren

         Temp1 = Temp1 Xor Temp2               'XOR-Verknpfung des Bit5

         Shift Temp0 , Right                   'alle Bits eins runter
         Temp0 = Temp0 Or Temp1                'Bit5 berschreiben

         Temp0 = Temp0 And 63                  'oberen 2Bit lschen
         Temp0 = Temp0 + 32                    'in den Bereich asc(32-95) verschieben

         Lcd Chr(temp0)                        'zeig
         Print Chr(temp0);
      Next
      Locate 2 , 1                             '2.Zeile zu 8 Zeichen
      Print
   Next
   Wait 5
End Sub
'-------------------------------------------------------------------------------
' lineares Schieberegister Bit5 XOR Bit4, nach Linksverschiebung in Bit0
Sub Codiere
   Cls                                         '1.Zeile zu 8 Zeichen
   For Index0 = 0 To 1                         '2 Zeilen
      For Index1 = 1 To 8                      'zu 8 Zeichen
         Read S                                'hol ein Zeichen
         S = Ucase(s)                          'nur Grossbuchstaben
         Temp0 = Asc(s) - 32                   'Bereich asc(32-95) auf 0-63 holen

         Temp1 = Temp0 And 16                  'Bit4 isolieren
         Shift Temp1 , Right , 4               'nach Bit0 schieben

         Temp2 = Temp0 And 32                  'Bit5 isolieren
         Shift Temp2 , Right , 5               'nach Bit0 schieben

         Temp1 = Temp1 Xor Temp2               'XOR-Verknpfung des Bit0

         Shift Temp0 , Left                    'alle Bit eins hoch
         Temp0 = Temp0 Or Temp1                'Bit0 berschreiben

         Temp0 = Temp0 And 63                  'oberen 2Bit lschen
         Temp0 = Temp0 + 32                    'in den Bereich asc(32-95) verschieben

         Lcd Chr(temp0)                        'zeig
         Print Chr(temp0);
      Next
      Locate 2 , 1                             '2.Zeile zu 8 Zeichen
      Print
   Next
   Wait 5
End Sub
'-------------------------------------------------------------------------------
Dta0:                                          'Rtsel-String
Data "+"
Data "9"
Data "+"
Data "7"
Data "H"
Data "D"
Data "?"
Data "="
Data "3"
Data "7"
Data ":"
Data "9"
Data "#"
Data "%"
Data "?"
Data "D"

Dta1:                                          'Rtsel-String
Data "E" , "l" , "e" , "k" , "t" , "r" , "o" , "n"
Data "i" , "k" , "-" , "L" , "a" , "b" , "o" , "r"

Dta2:                                          'Test-String
Data "F"
Data "?"
Data "-"
Data "H"
Data "N"
Data "#"
Data "D"
Data "+"
Data ":"
Data "D"
Data "#"
Data "+"
Data "H"
Data "F"
Data "+"
Data "9"

Dta3:                                          'Test-String
Data "S" , "o" , "f" , "t" , "w" , "a" , "r" , "e"
Data "-" , "R" , "a" , "e" , "t" , "s" , "e" , "l"
'-------------------------------------------------------------------------------
'           ______ 2313 ______
'           1-Reset     Vcc-20            +4,5V
' TL1       2-D0/Rx  Sck/B7-19 scl        ***
' TL2       3-D1/Tx Miso/B6-18            ***
' RS(lcd4)  4-A1/X2 Mosi/B5-17 sda        ***
' E (lcd6)  5-A0/X1      B4-16 Vo(lcd3)   ***
' Ti0       6-D2/Int0 OC/B3-15 d7(lcd10)
' TL3       7-D3/Int1 OC/B2-14 d6(lcd9)
' TL4       8-D4/T0 Ain1/B1-13 d5(lcd8)
' Buzz      9-D5/T1 Ain0/B0-12 d4(lcd7)
'           10-Gnd       D6-11 Vdd(lcd2)  ***
'End